import 'package:flutter/widgets.dart';

abstract class FormElement<T> {
  // Private variables
  Widget _widget;

  // Constructor
  FormElement();

  // Public methods
  Widget rebuild(BuildContext context) {
    _widget = build(context);
    return _widget;
  }

  // Abstract methods
  void initialize();
  Widget build(BuildContext context);
  void dispose();

  // Abstract getters
  T get value;
  set value(T value);

  // Getters
  Widget get widget => _widget;
}
